classdef Logger < handle
    %LOGGER Summary of this class goes here
    %   Detailed explanation goes here

    properties (Constant)
        LOG_FOLDER = "C:\Users\radamsteegt\Documents\MATLAB\logs\"
    end
    
    properties
        FileId (1,1) double {mustBeInteger} = -1
        FileName (1,1) string = ""
    end
    
    methods       
        function obj = Logger(fileName)
            arguments
                fileName (1,1) string
            end
            %LOGGER Construct an instance of this class
            %   Open a file with the specified file name for writing.
            obj.FileName = sprintf("%s%s_%s.log", obj.LOG_FOLDER, ...
                fileName, string(datetime('now', 'Format', ...
                'yyyyMMddHHmmssSSS')));
            obj.FileId = fopen(obj.FileName, 'w');
            if obj.FileId == -1
                error("Failed to open log file %s", obj.FileName)
            end
            obj.twritef("New log file opened")
        end
        
        function twritef(obj, str, varargin)
            arguments
                obj (1,1) Logger
                str (1,1) string
            end
            arguments (Repeating)
                varargin
            end
            %TWRITEF Write formatted to log file with timestamp
            %   Write specified string to the log file including a
            %   timestamp showing when the string has been written.
            text = sprintf(str, varargin{:});
            fprintf(obj.FileId, "[%s]: %s\n", string(datetime('now', ...
                'Format', 'dd-MMM-yyyy HH:mm:ss.SSS')), text);
        end
        
        function delete(obj)
            %DELETE Destruct class instance
            %   Use destructor to close the file and change the file to
            %   read-only to prevent accidental editing later on.
            if obj.FileId ~= -1
                obj.twritef("Log file closed")
                fclose(obj.FileId);
                fileattrib(obj.FileName, '-w')
            end
        end
    end
end

