fig_handle = figure(1);
nrows = 6;
ncols = 5;
corrScatterSize = 2;

% ret_range_rt = [-7.5, -3.5];
ret_range_4k = [-7.5, -0.5];
ret_range_rt = [-7.5, -0.5];
% ret_range_4k = [-7.5, -0.5];

% ticks_rt = ceil(min(ret_range_rt)):floor(max(ret_range_rt));
ticks_rt = ceil(min(ret_range_rt)):2:floor(max(ret_range_rt));
ticks_4k = ceil(min(ret_range_4k)):2:floor(max(ret_range_4k));

corr_yax_offset = [0, 2.75];
% colormap_4k_limit_tick_location = -0.5;
colormap_4k_limit_tick_location = -0.2;

colormap_rt_R = 1 - max(0, min((linspace(ret_range_rt(1),ret_range_rt(2),200) - log10(8e-8)) / (log10(1e-1)-log10(8e-8)), 1));
colormap_rt_G = 1 - colormap_rt_R;
colormap_rt_B = zeros(size(colormap_rt_R));

ret_range_max = 2.04e-2;
colormap_rt_R(linspace(min(ret_range_rt),max(ret_range_rt),200) > log10(ret_range_max)) = 0;
colormap_rt_G(linspace(min(ret_range_rt),max(ret_range_rt),200) > log10(ret_range_max)) = 0;
colormap_rt_B(linspace(min(ret_range_rt),max(ret_range_rt),200) > log10(ret_range_max)) = 1;
% Gradient mixing gamma correction: gamma = 2.2
colormap_rt = [colormap_rt_R(:), colormap_rt_G(:), colormap_rt_B(:)].^(1/2.2);

colormap_4k_R = 1 - max(0, min((linspace(ret_range_rt(1),ret_range_rt(2),200) - log10(8e-8)) / (log10(1e-1)-log10(8e-8)), 1));
colormap_4k_G = 1 - colormap_4k_R;
colormap_4k_B = zeros(size(colormap_4k_R));
% 2T NW-PR LVT 4K heatmap: extended upper boundary
ret_range_4k_max_2tnwprlvt = 1e-1;
colormap_4k_R(linspace(min(ret_range_4k),max(ret_range_4k),200) > log10(ret_range_4k_max_2tnwprlvt)) = 0;
colormap_4k_G(linspace(min(ret_range_4k),max(ret_range_4k),200) > log10(ret_range_4k_max_2tnwprlvt)) = 0;
colormap_4k_B(linspace(min(ret_range_4k),max(ret_range_4k),200) > log10(ret_range_4k_max_2tnwprlvt)) = 1;
% Gradient mixing gamma correction: gamma = 2.2
colormap_4k_2tnwprlvt = [colormap_4k_R(:), colormap_4k_G(:), colormap_4k_B(:)].^(1/2.2);
% Other 4K heatmaps
colormap_4k_R(linspace(min(ret_range_4k),max(ret_range_4k),200) > log10(ret_range_max)) = 0;
colormap_4k_G(linspace(min(ret_range_4k),max(ret_range_4k),200) > log10(ret_range_max)) = 0;
colormap_4k_B(linspace(min(ret_range_4k),max(ret_range_4k),200) > log10(ret_range_max)) = 1;
% Gradient mixing gamma correction: gamma = 2.2
colormap_4k = [colormap_4k_R(:), colormap_4k_G(:), colormap_4k_B(:)].^(1/2.2);

%% 2T SVT RT
subplot(nrows,ncols,1)
load('test6_mult_20230411090830355.mat')
retention_300K = reshape(min(criticalDelay(5,:,:,:,:), [], 3), [32, 32]);
retention_300K = 8e-8 + 2e-8 * retention_300K;
retention_300K_temp = startTemperature;
minRetTime(1,1) = min(retention_300K, [], "all");

emptyDisplayLabels = cell(32, 1);
for i = 1:32
    emptyDisplayLabels{i} = "";
end

heatmap(0:31, 0:31, retention_300K, 'GridVisible', 'off');
xlabel("Columns")
ylabel("Rows")
ax = gca;
ax.XDisplayLabels = emptyDisplayLabels;
ax.YDisplayLabels = emptyDisplayLabels;
colormap(ax, colormap_rt)
clim(log(10.^ret_range_rt))
set(gca, 'ColorScaling', 'log')
cb = struct(ax).Colorbar;
cb.Ticks = 10.^ticks_rt;
cb.TickLabels = arrayfun(@(x) sprintf("10^{%d}", log10(x)), cb.Ticks(cb.Ticks < 10^max(ret_range_rt)));
if cb.Ticks(end) < 10^max(ret_range_rt) && cb.Ticks(end) > ret_range_max
    cb.TickLabels{end} = '>2\times10^{-2}';
end
cblabel(1,1) = ylabel(cb, 'Ret. time [s]');

% Distribution
subplot(nrows,ncols,2);
[f,x] = ecdf(retention_300K(:));
stairs(x, f, 'k', 'LineWidth', 1)
set(gca, 'XScale', 'log')
xlim(10.^ret_range_rt)
xlabel('Ret. time [s]')
ylim([0,1])
ylabel('Cum. fraction')

fcn = @(b,x) normcdf(x, b(1), b(2));
NRCF = @(b) norm((f(2:end)-f(2))/(1-f(2)) - fcn(b, log(x(2:end))));
[~,idxMedian] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5));
[~,idxSigma] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5+0.341));
B = fminsearch(NRCF, [log(x(idxMedian)); log(x(idxMedian)) - log(x(idxSigma))]);
% B = [-13.4, 1.03];
hold on
normFitX = linspace(log(10^min(ret_range_rt)), log(10^max(ret_range_rt)), 100);
plot(exp(normFitX), f(2) + fcn(B, normFitX)*(1-f(2)), 'r--', 'LineWidth', 2.5)
hold off
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_rt;
lognormfitmu(1,1) = B(1);
lognormfitstd(1,1) = B(2);

%% 2T SVT 4K
subplot(nrows,ncols,3)
load('test6_20230302100942119.mat')
retention_4K = reshape(min(criticalDelay(1,:,:,:,:), [], 3), [32, 32]);
retention_4K = 8e-8 + 2e-8 * retention_4K;
retention_4K_temp = startTemperature;
infRetentionCount(1) = sum(retention_4K == Inf, "all");
minRetTime(1,2) = min(retention_4K, [], "all");

heatmap(0:31, 0:31, retention_4K, 'GridVisible', 'off')
xlabel("Columns")
ylabel("Rows")
ax = gca;
ax.XDisplayLabels = emptyDisplayLabels;
ax.YDisplayLabels = emptyDisplayLabels;
colormap(ax, colormap_4k)
clim(log(10.^ret_range_4k))
set(gca, 'ColorScaling', 'log')
cb = struct(ax).Colorbar;
cb.Ticks = 10.^[ticks_4k, colormap_4k_limit_tick_location];
cb.TickLabels = arrayfun(@(x) sprintf("10^{%d}", log10(x)), cb.Ticks(cb.Ticks < 10^max(ret_range_4k)));
cb.TickLabels{end} = '>2\times10^{-2}';
cblabel(1,2) = ylabel(cb, 'Ret. time [s]');

% Distribution
subplot(nrows,ncols,4)
[f,x] = ecdf(retention_4K(:));
stairs(x, f, 'k', 'LineWidth', 1)
set(gca, 'XScale', 'log')
xlim(10.^ret_range_4k)
xlabel('Ret. time [s]')
ylim([0,1])
ylabel('Cum. fraction')

fcn = @(b,x) normcdf(x, b(1), b(2));
NRCF = @(b) norm((f(2:end)-f(2))/(1-f(2)) - fcn(b, log(x(2:end))));
[~,idxMedian] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5));
[~,idxSigma] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5+0.341));
%B = fminsearch(NRCF, [log(x(idxMedian)); log(x(idxMedian)) - log(x(idxSigma))]);
Bguess = [-2.61, 1.15];
B = fminsearch(NRCF, Bguess);
% B = [-2.89, 1.16];
hold on
normFitX = linspace(log(10^min(ret_range_4k)), log(10^max(ret_range_4k)), 100);
plot(exp(normFitX), fcn(B, normFitX), 'b--', 'LineWidth', 1)
hold off
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_4k;
lognormfitmu(1,2) = B(1);
lognormfitstd(1,2) = B(2);
failrate(1) = sum(retention_4K(:) == 8e-8)/1024;

%% 2T SVT correlation
subplot(nrows,ncols,5)
scatter(retention_300K(:), retention_4K(:), corrScatterSize, 'k', 'filled')
yline(ret_range_max, 'k--', 'LineWidth', 1)
set(gca, 'XScale', 'log')
set(gca, 'YScale', 'log')
xlim(10.^ret_range_rt)
ylim(10.^(ret_range_4k + corr_yax_offset))
xlabel('RT Ret. [s]')
ylabel('4.2K Ret. [s]')
r300 = retention_300K(:);
r4 = retention_4K(:);
sel = (r300 > 8e-8) & (r300 < Inf) & (r4 > 8e-8) & (r4 < Inf);
[ret_corr(1), p_corr(1)] = corr(log(r300(sel)), log(r4(sel)));
title("Correlation") 
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_rt;
ax.YTick = 10.^ticks_4k;
box on

%% 2T LVT RT
subplot(nrows,ncols,ncols+1)
load('test6_mult_20230411090830355.mat')
retention_300K = reshape(min(criticalDelay(10,:,:,:,:), [], 3), [32, 32]);
retention_300K = 8e-8 + 2e-8 * retention_300K;
retention_300K_temp = startTemperature;
minRetTime(2,1) = min(retention_300K, [], "all");

emptyDisplayLabels = cell(32, 1);
for i = 1:32
    emptyDisplayLabels{i} = "";
end

heatmap(0:31, 0:31, retention_300K, 'GridVisible', 'off');
xlabel("Columns")
ylabel("Rows")
ax = gca;
ax.XDisplayLabels = emptyDisplayLabels;
ax.YDisplayLabels = emptyDisplayLabels;
colormap(ax, colormap_rt)
clim(log(10.^ret_range_rt))
set(gca, 'ColorScaling', 'log')
cb = struct(ax).Colorbar;
cb.Ticks = 10.^ticks_rt;
cb.TickLabels = arrayfun(@(x) sprintf("10^{%d}", log10(x)), cb.Ticks(cb.Ticks < 10^max(ret_range_rt)));
if cb.Ticks(end) < 10^max(ret_range_rt) && cb.Ticks(end) > ret_range_max
    cb.TickLabels{end} = '>2\times10^{-2}';
end
cblabel(2,1) = ylabel(cb, 'Ret. time [s]');

% Distribution
subplot(nrows,ncols,ncols+2)
[f,x] = ecdf(retention_300K(:));
stairs(x, f, 'k', 'LineWidth', 1)
set(gca, 'XScale', 'log')
xlim(10.^ret_range_rt)
xlabel('Ret. time [s]')
ylim([0,1])
ylabel('Cum. fraction')

fcn = @(b,x) normcdf(x, b(1), b(2));
NRCF = @(b) norm((f(2:end)-f(2))/(1-f(2)) - fcn(b, log(x(2:end))));
[~,idxMedian] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5));
[~,idxSigma] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5+0.341));
B = fminsearch(NRCF, [log(x(idxMedian)); log(x(idxMedian)) - log(x(idxSigma))]);
% B = [-13.4, 1.03];
hold on
normFitX = linspace(log(10^min(ret_range_rt)), log(10^max(ret_range_rt)), 100);
plot(exp(normFitX), f(2) + fcn(B, normFitX)*(1-f(2)), 'r--', 'LineWidth', 2.5)
hold off
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_rt;
lognormfitmu(2,1) = B(1);
lognormfitstd(2,1) = B(2);
failrate(2) = sum(retention_300K(:) == 8e-8)/1024;

%% 2T LVT 4K
subplot(nrows,ncols,ncols+3)
load('test6_20230310110423629.mat')
retention_4K = reshape(min(criticalDelay, [], 3), [32, 32]);
% load('test6_mult_20230405221043008.mat')
% retention_4K = reshape(min(criticalDelay(5,:,:,:,:), [], 3), [32, 32]);
retention_4K = 8e-8 + 2e-8 * retention_4K;
retention_4K_temp = startTemperature;
infRetentionCount(2) = sum(retention_4K == Inf, "all");
minRetTime(2,2) = min(retention_4K, [], "all");

heatmap(0:31, 0:31, retention_4K, 'GridVisible', 'off')
xlabel("Columns")
ylabel("Rows")
ax = gca;
ax.XDisplayLabels = emptyDisplayLabels;
ax.YDisplayLabels = emptyDisplayLabels;
colormap(ax, colormap_4k_2tnwprlvt)
clim(log(10.^ret_range_4k))
set(gca, 'ColorScaling', 'log')
cb = struct(ax).Colorbar;
cb.Ticks = 10.^[ticks_4k, colormap_4k_limit_tick_location];
cb.TickLabels = arrayfun(@(x) sprintf("10^{%d}", log10(x)), cb.Ticks(cb.Ticks < 10^max(ret_range_4k)));
cb.TickLabels{end} = '>10^{-1}';
cblabel(2,2) = ylabel(cb, 'Ret. time [s]');

% Distribution
subplot(nrows,ncols,ncols+4)
[f,x] = ecdf(retention_4K(:));
stairs(x, f, 'k', 'LineWidth', 1)
set(gca, 'XScale', 'log')
xlim(10.^ret_range_4k)
xlabel('Ret. time [s]')
ylim([0,1])
ylabel('Cum. fraction')

fcn = @(b,x) normcdf(x, b(1), b(2));
NRCF = @(b) norm((f(2:end)-f(2))/(1-f(2)) - fcn(b, log(x(2:end))));
[~,idxMedian] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5));
[~,idxSigma] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5+0.341));
B = fminsearch(NRCF, [log(x(idxMedian)); log(x(idxMedian)) - log(x(idxSigma))]);
% B = [-2.89, 1.16];
hold on
normFitX = linspace(log(10^min(ret_range_4k)), log(10^max(ret_range_4k)), 100);
plot(exp(normFitX), f(2) + fcn(B, normFitX)*(1-f(2)), 'b--', 'LineWidth', 2.5)
hold off
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_4k;
lognormfitmu(2,2) = B(1);
lognormfitstd(2,2) = B(2);

%% 2T LVT correlation
subplot(nrows,ncols,ncols+5)
scatter(retention_300K(:), retention_4K(:), corrScatterSize, 'k', 'filled')
yline(ret_range_4k_max_2tnwprlvt, 'k--', 'LineWidth', 1)
% hold on
% scatter(retention_300K(1,1), retention_4K(1,1), 5, 'r', 'filled')
% hold off
set(gca, 'XScale', 'log')
set(gca, 'YScale', 'log')
xlim(10.^ret_range_rt)
ylim(10.^(ret_range_4k + corr_yax_offset))
xlabel('RT Ret. [s]')
ylabel('4.2K Ret. [s]')
r300 = retention_300K(:);
r4 = retention_4K(:);
sel = (r300 > 8e-8) & (r300 < Inf) & (r4 > 8e-8) & (r4 < Inf);
[ret_corr(2), p_corr(2)] = corr(log(r300(sel)), log(r4(sel)));
title("Correlation") 
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_rt;
ax.YTick = 10.^ticks_4k;
box on

%% 3T NWPR SVT RT
subplot(nrows,ncols,2*ncols+1)
load('test6_mult_20230411090830355.mat')
retention_300K = reshape(min(criticalDelay(12,:,:,:,:), [], 3), [32, 32]);
retention_300K = 8e-8 + 2e-8 * retention_300K;
retention_300K_temp = startTemperature;
minRetTime(3,1) = min(retention_300K, [], "all");

emptyDisplayLabels = cell(32, 1);
for i = 1:32
    emptyDisplayLabels{i} = "";
end

heatmap(0:31, 0:31, retention_300K, 'GridVisible', 'off');
xlabel("Columns")
ylabel("Rows")
ax = gca;
ax.XDisplayLabels = emptyDisplayLabels;
ax.YDisplayLabels = emptyDisplayLabels;
colormap(ax, colormap_rt)
clim(log(10.^ret_range_rt))
set(gca, 'ColorScaling', 'log')
cb = struct(ax).Colorbar;
cb.Ticks = 10.^ticks_rt;
cb.TickLabels = arrayfun(@(x) sprintf("10^{%d}", log10(x)), cb.Ticks(cb.Ticks < 10^max(ret_range_rt)));
if cb.Ticks(end) < 10^max(ret_range_rt) && cb.Ticks(end) > ret_range_max
    cb.TickLabels{end} = '>2\times10^{-2}';
end
cblabel(3,1) = ylabel(cb, 'Ret. time [s]');

% Distribution
subplot(nrows,ncols,2*ncols+2)
[f,x] = ecdf(retention_300K(:));
stairs(x, f, 'k', 'LineWidth', 1)
set(gca, 'XScale', 'log')
xlim(10.^ret_range_rt)
xlabel('Ret. time [s]')
ylim([0,1])
ylabel('Cum. fraction')

fcn = @(b,x) normcdf(x, b(1), b(2));
NRCF = @(b) norm((f(2:end)-f(2))/(1-f(2)) - fcn(b, log(x(2:end))));
[~,idxMedian] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5));
[~,idxSigma] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5+0.341));
B = fminsearch(NRCF, [log(x(idxMedian)); log(x(idxMedian)) - log(x(idxSigma))]);
% B = [-13.4, 1.03];
hold on
normFitX = linspace(log(10^min(ret_range_rt)), log(10^max(ret_range_rt)), 100);
plot(exp(normFitX), f(2) + fcn(B, normFitX)*(1-f(2)), 'r--', 'LineWidth', 2.5)
hold off
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_rt;
lognormfitmu(3,1) = B(1);
lognormfitstd(3,1) = B(2);

%% 3T NWPR SVT 4K
subplot(nrows,ncols,2*ncols+3)
load('test6_mult_20230405221043008.mat')
retention_4K = reshape(min(criticalDelay(9,:,:,:,:), [], 3), [32, 32]);
retention_4K = 8e-8 + 2e-8 * retention_4K;
retention_4K_temp = startTemperature;
minRetTime(3,2) = min(retention_4K, [], "all");
infRetentionCount(3) = sum(retention_4K == Inf, "all");

heatmap(0:31, 0:31, retention_4K, 'GridVisible', 'off')
xlabel("Columns")
ylabel("Rows")
ax = gca;
ax.XDisplayLabels = emptyDisplayLabels;
ax.YDisplayLabels = emptyDisplayLabels;
colormap(ax, colormap_4k)
clim(log(10.^ret_range_4k))
set(gca, 'ColorScaling', 'log')
cb = struct(ax).Colorbar;
cb.Ticks = 10.^[ticks_4k, colormap_4k_limit_tick_location];
cb.TickLabels = arrayfun(@(x) sprintf("10^{%d}", log10(x)), cb.Ticks(cb.Ticks < 10^max(ret_range_4k)));
cb.TickLabels{end} = '>2\times10^{-2}';
cb.Ruler.TickLabelFormat = '%e';
cblabel(3,2) = ylabel(cb, 'Ret. time [s]');

% Distribution
subplot(nrows,ncols,2*ncols+4)
[f,x] = ecdf(retention_4K(:));
stairs(x, f, 'k', 'LineWidth', 1)
set(gca, 'XScale', 'log')
xlim(10.^ret_range_4k)
xlabel('Ret. time [s]')
ylim([0,1])
ylabel('Cum. fraction')

fcn = @(b,x) normcdf(x, b(1), b(2));
NRCF = @(b) norm((f(2:end)-f(2))/(1-f(2)) - fcn(b, log(x(2:end))));
[~,idxMedian] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5));
[~,idxSigma] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5+0.341));
B = fminsearch(NRCF, [log(x(idxMedian)); log(x(idxMedian)) - log(x(idxSigma))]);
% B = [-2.89, 1.16];
hold on
normFitX = linspace(log(10^min(ret_range_4k)), log(10^max(ret_range_4k)), 100);
plot(exp(normFitX), f(2) + fcn(B, normFitX)*(1-f(2)), 'b--', 'LineWidth', 2.5)
hold off
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_4k;
lognormfitmu(3,2) = B(1);
lognormfitstd(3,2) = B(2);

%% 3T NWPR SVT correlation
subplot(nrows,ncols,2*ncols+5)
scatter(retention_300K(:), retention_4K(:), corrScatterSize, 'k', 'filled')
yline(ret_range_max, 'k--', 'LineWidth', 2)
set(gca, 'XScale', 'log')
set(gca, 'YScale', 'log')
xlim(10.^ret_range_rt)
ylim(10.^(ret_range_4k + corr_yax_offset))
xlabel('RT Ret. [s]')
ylabel('4.2K Ret. [s]')
r300 = retention_300K(:);
r4 = retention_4K(:);
sel = (r300 > 8e-8) & (r300 < Inf) & (r4 > 8e-8) & (r4 < Inf);
[ret_corr(3), p_corr(3)] = corr(log(r300(sel)), log(r4(sel)));
title("Correlation") 
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_rt;
ax.YTick = 10.^ticks_4k;
box on

%% 3T NWPR LVT RT
subplot(nrows,ncols,3*ncols+1)
load('test6_mult_20230411090830355.mat')
retention_300K = reshape(min(criticalDelay(17,:,:,:,:), [], 3), [32, 32]);
retention_300K = 8e-8 + 2e-8 * retention_300K;
retention_300K_temp = startTemperature;
minRetTime(4,1) = min(retention_300K, [], "all");

emptyDisplayLabels = cell(32, 1);
for i = 1:32
    emptyDisplayLabels{i} = "";
end

heatmap(0:31, 0:31, retention_300K, 'GridVisible', 'off');
xlabel("Columns")
ylabel("Rows")
ax = gca;
ax.XDisplayLabels = emptyDisplayLabels;
ax.YDisplayLabels = emptyDisplayLabels;
colormap(ax, colormap_rt)
clim(log(10.^ret_range_rt))
set(gca, 'ColorScaling', 'log')
cb = struct(ax).Colorbar;
cb.Ticks = 10.^ticks_rt;
cb.TickLabels = arrayfun(@(x) sprintf("10^{%d}", log10(x)), cb.Ticks(cb.Ticks < 10^max(ret_range_rt)));
if cb.Ticks(end) < 10^max(ret_range_rt) && cb.Ticks(end) > ret_range_max
    cb.TickLabels{end} = '>2\times10^{-2}';
end
cblabel(4,1) = ylabel(cb, 'Ret. time [s]');

% Distribution
subplot(nrows,ncols,3*ncols+2)
[f,x] = ecdf(retention_300K(:));
stairs(x, f, 'k', 'LineWidth', 1)
set(gca, 'XScale', 'log')
xlim(10.^ret_range_rt)
xlabel('Ret. time [s]')
ylim([0,1])
ylabel('Cum. fraction')

fcn = @(b,x) normcdf(x, b(1), b(2));
NRCF = @(b) norm((f(2:end)-f(2))/(1-f(2)) - fcn(b, log(x(2:end))));
[~,idxMedian] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5));
[~,idxSigma] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5+0.341));
B = fminsearch(NRCF, [log(x(idxMedian)); log(x(idxMedian)) - log(x(idxSigma))]);
% B = [-13.4, 1.03];
hold on
normFitX = linspace(log(10^min(ret_range_rt)), log(10^max(ret_range_rt)), 100);
plot(exp(normFitX), f(2) + fcn(B, normFitX)*(1-f(2)), 'r--', 'LineWidth', 2.5)
yline(f(2), 'k--', 'LineWidth', 1)
hold off
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_rt;
lognormfitmu(4,1) = B(1);
lognormfitstd(4,1) = B(2);
failrate(3) = sum(retention_300K(:) == 8e-8)/1024;

%% 3T NWPR LVT 4K
subplot(nrows,ncols,3*ncols+3)
load('test6_mult_20230405221043008.mat')
retention_4K = reshape(min(criticalDelay(12,:,:,:,:), [], 3), [32, 32]);
retention_4K = 8e-8 + 2e-8 * retention_4K;
retention_4K_temp = startTemperature;
minRetTime(4,2) = min(retention_4K, [], "all");
infRetentionCount(4) = sum(retention_4K == Inf, "all");

heatmap(0:31, 0:31, retention_4K, 'GridVisible', 'off')
xlabel("Columns")
ylabel("Rows")
ax = gca;
ax.XDisplayLabels = emptyDisplayLabels;
ax.YDisplayLabels = emptyDisplayLabels;
colormap(ax, colormap_4k)
clim(log(10.^ret_range_4k))
set(gca, 'ColorScaling', 'log')
cb = struct(ax).Colorbar;
cb.Ticks = 10.^[ticks_4k, colormap_4k_limit_tick_location];
cb.TickLabels = arrayfun(@(x) sprintf("10^{%d}", log10(x)), cb.Ticks(cb.Ticks < 10^max(ret_range_4k)));
cb.TickLabels{end} = '>2\times10^{-2}';
cblabel(4,2) = ylabel(cb, 'Ret. time [s]');

% Distribution
subplot(nrows,ncols,3*ncols+4)
[f,x] = ecdf(retention_4K(:));
stairs(x, f, 'k', 'LineWidth', 1)
set(gca, 'XScale', 'log')
xlim(10.^ret_range_4k)
xlabel('Ret. time [s]')
ylim([0,1])
ylabel('Cum. fraction')

fcn = @(b,x) normcdf(x, b(1), b(2));
NRCF = @(b) norm((f(2:end)-f(2))/(1-f(2)) - fcn(b, log(x(2:end))));
[~,idxMedian] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5));
[~,idxSigma] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5+0.341));
B = fminsearch(NRCF, [log(x(idxMedian)); log(x(idxMedian)) - log(x(idxSigma))]);
% B = [-2.89, 1.16];
hold on
normFitX = linspace(log(10^min(ret_range_4k)), log(10^max(ret_range_4k)), 100);
plot(exp(normFitX), f(2) + fcn(B, normFitX)*(1-f(2)), 'b--', 'LineWidth', 2.5)
hold off
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_4k;
lognormfitmu(4,2) = B(1);
lognormfitstd(4,2) = B(2);

%% 3T NWPR LVT correlation
subplot(nrows,ncols,3*ncols+5)
scatter(retention_300K(:), retention_4K(:), corrScatterSize, 'k', 'filled')
yline(ret_range_max, 'k--', 'LineWidth', 2)
set(gca, 'XScale', 'log')
set(gca, 'YScale', 'log')
xlim(10.^ret_range_rt)
ylim(10.^(ret_range_4k + corr_yax_offset))
xlabel('RT Ret. [s]')
ylabel('4.2K Ret. [s]')
r300 = retention_300K(:);
r4 = retention_4K(:);
sel = (r300 > 8e-8) & (r300 < Inf) & (r4 > 8e-8) & (r4 < Inf);
[ret_corr(4), p_corr(4)] = corr(log(r300(sel)), log(r4(sel)));
title("Correlation") 
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_rt;
ax.YTick = 10.^ticks_4k;
box on

%% 3T PWPR SVT RT
subplot(nrows,ncols,4*ncols+1)
load('test6_mult_20230411090830355.mat')
retention_300K = reshape(min(criticalDelay(25,:,:,:,:), [], 3), [32, 32]);
retention_300K = 8e-8 + 2e-8 * retention_300K;
retention_300K_temp = startTemperature;
minRetTime(5,1) = min(retention_300K, [], "all");

emptyDisplayLabels = cell(32, 1);
for i = 1:32
    emptyDisplayLabels{i} = "";
end

heatmap(0:31, 0:31, retention_300K, 'GridVisible', 'off');
xlabel("Columns")
ylabel("Rows")
ax = gca;
ax.XDisplayLabels = emptyDisplayLabels;
ax.YDisplayLabels = emptyDisplayLabels;
colormap(ax, colormap_rt)
clim(log(10.^ret_range_rt))
set(gca, 'ColorScaling', 'log')
cb = struct(ax).Colorbar;
cb.Ticks = 10.^ticks_rt;
cb.TickLabels = arrayfun(@(x) sprintf("10^{%d}", log10(x)), cb.Ticks(cb.Ticks < 10^max(ret_range_rt)));
if cb.Ticks(end) < 10^max(ret_range_rt) && cb.Ticks(end) > ret_range_max
    cb.TickLabels{end} = '>2\times10^{-2}';
end
cblabel(5,1) = ylabel(cb, 'Ret. time [s]');

% Distribution
subplot(nrows,ncols,4*ncols+2)
[f,x] = ecdf(retention_300K(:));
stairs(x, f, 'k', 'LineWidth', 1)
set(gca, 'XScale', 'log')
xlim(10.^ret_range_rt)
xlabel('Ret. time [s]')
ylim([0,1])
ylabel('Cum. fraction')

fcn = @(b,x) normcdf(x, b(1), b(2));
NRCF = @(b) norm((f(2:end)-f(2))/(1-f(2)) - fcn(b, log(x(2:end))));
[~,idxMedian] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5));
[~,idxSigma] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5+0.341));
B = fminsearch(NRCF, [log(x(idxMedian)); log(x(idxMedian)) - log(x(idxSigma))]);
% B = [-13.4, 1.03];
hold on
normFitX = linspace(log(10^min(ret_range_rt)), log(10^max(ret_range_rt)), 100);
plot(exp(normFitX), f(2) + fcn(B, normFitX)*(1-f(2)), 'r--', 'LineWidth', 2.5)
hold off
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_rt;
lognormfitmu(5,1) = B(1);
lognormfitstd(5,1) = B(2);

%% 3T PWPR SVT 4K
subplot(nrows,ncols,4*ncols+3)
load('test6_mult_20230406082430754.mat')
retention_4K = reshape(min(criticalDelay(1,:,:,:,:), [], 3), [32, 32]);
retention_4K = 8e-8 + 2e-8 * retention_4K;
retention_4K_temp = startTemperature;
minRetTime(5,2) = min(retention_4K, [], "all");
infRetentionCount(5) = sum(retention_4K == Inf, "all");

heatmap(0:31, 0:31, retention_4K, 'GridVisible', 'off')
xlabel("Columns")
ylabel("Rows")
ax = gca;
ax.XDisplayLabels = emptyDisplayLabels;
ax.YDisplayLabels = emptyDisplayLabels;
colormap(ax, colormap_4k)
clim(log(10.^ret_range_4k))
set(gca, 'ColorScaling', 'log')
cb = struct(ax).Colorbar;
cb.Ticks = 10.^[ticks_4k, colormap_4k_limit_tick_location];
cb.TickLabels = arrayfun(@(x) sprintf("10^{%d}", log10(x)), cb.Ticks(cb.Ticks < 10^max(ret_range_4k)));
cb.TickLabels{end} = '>2\times10^{-2}';
cblabel(5,2) = ylabel(cb, 'Ret. time [s]');

% Distribution
subplot(nrows,ncols,4*ncols+4)
[f,x] = ecdf(retention_4K(:));
stairs(x, f, 'k', 'LineWidth', 1)
set(gca, 'XScale', 'log')
xlim(10.^ret_range_4k)
xlabel('Ret. time [s]')
ylim([0.825,1])
ylabel('Cum. fraction')

fcn = @(b,x) normcdf(x, b(1), b(2));
NRCF = @(b) norm((f(2:end)-f(2))/(1-f(2)) - fcn(b, log(x(2:end))));
[~,idxMedian] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5));
[~,idxSigma] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5+0.341));
B = fminsearch(NRCF, [log(x(idxMedian+1)); log(x(idxMedian+1)) - log(x(idxSigma+1))]);
% B = [-2.89, 1.16];
hold on
normFitX = linspace(log(10^min(ret_range_4k)), log(10^max(ret_range_4k)), 100);
plot(exp(normFitX), f(2) + fcn(B, normFitX)*(1-f(2)), 'b--', 'LineWidth', 2.5)
yline(f(2), 'k--', 'LineWidth', 1)
hold off
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_4k;
ax.YTick = 0.85:0.05:1;
lognormfitmu(5,2) = B(1);
lognormfitstd(5,2) = B(2);
failrate(4) = sum(retention_4K(:) == 8e-8)/1024;

%% 3T PWPR SVT correlation
subplot(nrows,ncols,4*ncols+5)
scatter(retention_300K(:), retention_4K(:), corrScatterSize, 'k', 'filled')
yline(ret_range_max, 'k--', 'LineWidth', 1)
set(gca, 'XScale', 'log')
set(gca, 'YScale', 'log')
xlim(10.^ret_range_rt)
ylim(10.^(ret_range_4k + corr_yax_offset))
xlabel('RT Ret. [s]')
ylabel('4.2K Ret. [s]')
r300 = retention_300K(:);
r4 = retention_4K(:);
sel = (r300 > 8e-8) & (r300 < Inf) & (r4 > 8e-8) & (r4 < Inf);
[ret_corr(5), p_corr(5)] = corr(log(r300(sel)), log(r4(sel)));
title("Correlation") 
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_rt;
ax.YTick = 10.^ticks_4k;
box on

%% 3T PWPR LVT RT
subplot(nrows,ncols,5*ncols+1)
load('test6_mult_20230411090830355.mat')
retention_300K = reshape(min(criticalDelay(30,:,:,:,:), [], 3), [32, 32]);
retention_300K = 8e-8 + 2e-8 * retention_300K;
retention_300K_temp = startTemperature;
minRetTime(6,1) = min(retention_300K, [], "all");

emptyDisplayLabels = cell(32, 1);
for i = 1:32
    emptyDisplayLabels{i} = "";
end

heatmap(0:31, 0:31, retention_300K, 'GridVisible', 'off');
xlabel("Columns")
ylabel("Rows")
ax = gca;
ax.XDisplayLabels = emptyDisplayLabels;
ax.YDisplayLabels = emptyDisplayLabels;
colormap(ax, colormap_rt)
clim(log(10.^ret_range_rt))
set(gca, 'ColorScaling', 'log')
cb = struct(ax).Colorbar;
cb.Ticks = 10.^ticks_rt;
cb.TickLabels = arrayfun(@(x) sprintf("10^{%d}", log10(x)), cb.Ticks(cb.Ticks < 10^max(ret_range_rt)));
if cb.Ticks(end) < 10^max(ret_range_rt) && cb.Ticks(end) > ret_range_max
    cb.TickLabels{end} = '>2\times10^{-2}';
end
cblabel(6,1) = ylabel(cb, 'Ret. time [s]');

% Distribution
subplot(nrows,ncols,5*ncols+2)
[f,x] = ecdf(retention_300K(:));
stairs(x, f, 'k', 'LineWidth', 1)
set(gca, 'XScale', 'log')
xlim(10.^ret_range_rt)
xlabel('Ret. time [s]')
ylim([0,1])
ylabel('Cum. fraction')

fcn = @(b,x) normcdf(x, b(1), b(2));
NRCF = @(b) norm((f(2:end)-f(2))/(1-f(2)) - fcn(b, log(x(2:end))));
[~,idxMedian] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5));
[~,idxSigma] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5+0.341));
B = fminsearch(NRCF, [log(x(idxMedian)); log(x(idxMedian)) - log(x(idxSigma))]);
% B = [-13.4, 1.03];
hold on
normFitX = linspace(log(10^min(ret_range_rt)), log(10^max(ret_range_rt)), 100);
plot(exp(normFitX), f(2) + fcn(B, normFitX)*(1-f(2)), 'r--', 'LineWidth', 2.5)
hold off
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_rt;
lognormfitmu(6,1) = B(1);
lognormfitstd(6,1) = B(2);

%% 3T PWPR LVT 4K
subplot(nrows,ncols,5*ncols+3)
load('test6_mult_20230406082430754.mat')
retention_4K = reshape(min(criticalDelay(2,:,:,:,:), [], 3), [32, 32]);
retention_4K = 8e-8 + 2e-8 * retention_4K;
retention_4K_temp = startTemperature;
minRetTime(6,2) = min(retention_4K, [], "all");
infRetentionCount(6) = sum(retention_4K == Inf, "all");

heatmap(0:31, 0:31, retention_4K, 'GridVisible', 'off')
xlabel("Columns")
ylabel("Rows")
ax = gca;
ax.XDisplayLabels = emptyDisplayLabels;
ax.YDisplayLabels = emptyDisplayLabels;
colormap(ax, colormap_4k)
clim(log(10.^ret_range_4k))
set(gca, 'ColorScaling', 'log')
cb = struct(ax).Colorbar;
cb.Ticks = 10.^[ticks_4k, colormap_4k_limit_tick_location];
cb.TickLabels = arrayfun(@(x) sprintf("10^{%d}", log10(x)), cb.Ticks(cb.Ticks < 10^max(ret_range_4k)));
cb.TickLabels{end} = '>2\times10^{-2}';
cblabel(6,2) = ylabel(cb, 'Ret. time [s]');

% Distribution
subplot(nrows,ncols,5*ncols+4)
[f,x] = ecdf(retention_4K(:));
stairs(x, f, 'k', 'LineWidth', 1)
set(gca, 'XScale', 'log')
xlim(10.^ret_range_4k)
xlabel('Ret. time [s]')
ylim([0,1])
ylabel('Cum. fraction')

fcn = @(b,x) normcdf(x, b(1), b(2));
NRCF = @(b) norm((f(2:end)-f(2))/(1-f(2)) - fcn(b, log(x(2:end))));
[~,idxMedian] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5));
[~,idxSigma] = min(abs((f(2:end)-f(2))/(1-f(2))-0.5+0.341));
B = fminsearch(NRCF, [log(x(idxMedian+1)); log(x(idxMedian+1)) - log(x(idxSigma+1))]);
% B = [-2.89, 1.16];
hold on
normFitX = linspace(log(10^min(ret_range_4k)), log(10^max(ret_range_4k)), 100);
plot(exp(normFitX), f(2) + fcn(B, normFitX)*(1-f(2)), 'b--', 'LineWidth', 2.5)
yline(f(2), 'k--', 'LineWidth', 1)
hold off
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_4k;
lognormfitmu(6,2) = B(1);
lognormfitstd(6,2) = B(2);
failrate(5) = sum(retention_4K(:) == 8e-8)/1024;

%% 3T PWPR LVT correlation
subplot(nrows,ncols,5*ncols+5)
scatter(retention_300K(:), retention_4K(:), corrScatterSize, 'k', 'filled')
yline(ret_range_max, 'k--', 'LineWidth', 1)
set(gca, 'XScale', 'log')
set(gca, 'YScale', 'log')
xlim(10.^ret_range_rt)
ylim(10.^(ret_range_4k + corr_yax_offset))
xlabel('RT Ret. [s]')
ylabel('4.2K Ret. [s]')
r300 = retention_300K(:);
r4 = retention_4K(:);
sel = (r300 > 8e-8) & (r300 < Inf) & (r4 > 8e-8) & (r4 < Inf);
[ret_corr(6), p_corr(6)] = corr(log(r300(sel)), log(r4(sel)));
title("Correlation") 
grid on
ax = gca;
ax.XMinorGrid = "off";
ax.YMinorGrid = "off";
ax.XTick = 10.^ticks_rt;
ax.YTick = 10.^ticks_4k;
box on

%%
for row = 1:nrows
    for col = 1:ncols
        sub_handle(row,col) = subplot(nrows,ncols,(row-1)*ncols+col);
    end
end

%%
fig_width  = 18; %cm
fig_height = 20; %cm
sub_width  = 0.11;
sub_height = 0.09;
sub_xoff   = 0.04;
sub_yoff   = 0.055;
even_sub_xoff = 0.03;
third_col_sub_xoff = -0.005;
set(fig_handle, "Units", "centimeters")
%set(fig_handle, 'Position',[60 25 fig_width fig_height]);
%set(fig_handle, 'Position',[-20 -5 fig_width fig_height]);
set(fig_handle, 'Position',[0 0 fig_width fig_height]);
for row = 1:nrows
    for col = 1:ncols
        set(sub_handle(row,col), 'Position', [(col-1)/ncols + sub_xoff + even_sub_xoff * (1 - mod(col, 2)) + third_col_sub_xoff * (col == 3), (nrows - row)/nrows + sub_yoff, sub_width, sub_height]);
        set(sub_handle(row,col), "FontName", "Times")
        set(sub_handle(row,col), "FontSize", 8)
%         set(sub_handle(row,col), 'Position', [(col-1)/ncols + sub_xoff, (nrows - row)/nrows + sub_yoff, sub_width, sub_height]);
    end
end

% Titles
titles = [
    "2T NW-PR SVT @ RT", "2T NW-PR SVT @ 4.2K";
    "2T NW-PR LVT @ RT", "2T NW-PR LVT @ 4.2K";
    "3T NW-PR SVT @ RT", "3T NW-PR SVT @ 4.2K";
    "3T NW-PR LVT @ RT", "3T NW-PR LVT @ 4.2K";
    "3T PW-PR SVT @ RT", "3T PW-PR SVT @ 4.2K";
    "3T PW-PR LVT @ RT", "3T PW-PR LVT @ 4.2K"
];
for row = 1:nrows
    for col = [1,3]
        dim = [(col-1)/ncols + sub_xoff + third_col_sub_xoff * (col == 3), (nrows - row)/nrows + sub_yoff + sub_height, 2*(sub_width + sub_xoff) + even_sub_xoff + third_col_sub_xoff * (col == 3), 0.03];
        annotation('textbox', dim, 'String', titles(row, (col+1)/2), "FontName", "Times", "FontSize", 9, "FontWeight", "bold", "HorizontalAlignment", "center", "LineStyle", "none")
    end
end

% Graph numbers/letters
label_xoff = 0;
label_yoff = 0.00;
for row = 1:nrows
    for col = 1:ncols
        txt = sprintf("(%c-%d)", char(96+row), col);
        dim = [(col-1)/ncols + label_xoff, (nrows - row)/nrows + label_yoff, sub_width, 0.03];
        annotation('textbox', dim, 'String', txt, "FontName", "Times", "FontSize", 9, "LineStyle", "none")
    end
end

% Distribution annotations
dist_xoff = [
    0.0385, -0.005;
    0.0385, -0.005;
    0.0385, -0.008;
    0.0385, -0.008;
    0.0385, -0.005;
    0.0385, -0.005
];
dist_yoff = [
    -0.05, 0.005;
    -0.036, 0.005;
    -0.05, 0.005;
    -0.032, 0.005;
    -0.05, 0.005;
    -0.05, 0.005
];
for row = 1:nrows
    for col = [2,4]
        pos = sub_handle(row, col).Position;
        pos = pos + [dist_xoff(row,col/2), dist_yoff(row,col/2), 0.05, 0];
        txt = {sprintf("\\mu = %.3g", lognormfitmu(row,col/2)), sprintf("\\sigma = %.2f", lognormfitstd(row,col/2))};
        if (row ~= 2) && col == 4
            if infRetentionCount(row) > 0
                % text = {sprintf("%d\\times > 2\times10^{-2}", infRetentionCount(row)), text{1}, text{2}};
                txt = {sprintf("%d\\times > 0.02", infRetentionCount(row)), txt{1}, txt{2}};
            end
        end
        if (row == 2) && col == 4
            % text = {sprintf("%d\\times > 10^{-1}", infRetentionCount(row)), text{1}, text{2}};
            txt = {sprintf("%d\\times > 0.1", infRetentionCount(row)), txt{1}, txt{2}};
        end
        annotation('textbox', pos, 'String', txt, "FontSize", 8, "FontName", "Times", "LineStyle", "none")
    end
end
% Failure annotations
% 2T SVT 4K
pos = sub_handle(1,4).Position;
pos = pos + [0, 0, 0, 0];
txt = sprintf("%d fail", failrate(1)*1024);
annotation('textbox', pos, 'String', txt, "FontSize", 8, "FontName", "Times", "LineStyle", "none", "VerticalAlignment", "bottom", "HorizontalAlignment", "left")
% 2T/3T NW-PR LVT RT
fail_yoff = [-0.008, -0.004];
for row = [2,4]
    pos = sub_handle(row,2).Position;
    pos = pos + [0.01, fail_yoff(row/2), 0, 0];
    txt = sprintf("%d fail", failrate(1+row/2)*1024);
    annotation('textbox', pos, 'String', txt, "FontSize", 8, "FontName", "Times", "LineStyle", "none", "VerticalAlignment", "bottom", "HorizontalAlignment", "center")
end
% 3T PW-PR 4K failures
for row = 5:6
    pos = sub_handle(row,4).Position;
    pos = pos + [-0.015, -0.005, 0.03, 0];
    txt = sprintf("%d fail", failrate(row-1)*1024);
    annotation('textbox', pos, 'String', txt, "FontSize", 8, "FontName", "Times", "LineStyle", "none", "VerticalAlignment", "bottom", "HorizontalAlignment", "center")
end

% Correlation annotations
for row = 1:6
    pos = sub_handle(row,5).Position;
    pos = pos + [-0.015, 0.007, 0.03, 0];
    txt = {sprintf("r = %.3f", ret_corr(row)), sprintf("P = %.3f", p_corr(row))};
    annotation('textbox', pos, 'String', txt, "FontSize", 8, "FontName", "Times", "LineStyle", "none", "VerticalAlignment", "top", "HorizontalAlignment", "center")
end

% Position colorbar labels
for row = 1:6
    for col = 1:2
        cblabel(row,col).Position(1) = 4;
    end
end

% Minimum retention time annotations
min_xoff = 0.03;
min_yoff = 0.01;
for row = 1:6
    for col = [1,3]
        mintret = minRetTime(row, (col+1)/2);
        txt = sprintf("min = %.2f\\times10^{%d} s", mintret/10^(floor(log10(mintret))), floor(log10(mintret)));
        dim = [(col-1)/ncols + min_xoff, (nrows - row)/nrows + min_yoff, sub_width, 0.03];
        %annotation('textbox', dim, 'String', text, "FontName", "Times", "FontSize", 8, "LineStyle", "none", "HorizontalAlignment", "center")
    end
end

%%
fig_handle.Renderer = "painters";
saveas(fig_handle, "H:\My Documents\CryoMemory_measurements\MATLAB\figures_jssc\dram_retention_v5.eps", 'epsc')