%% Load RT data
% Dynamic memories
load("test5_20230330083947528.mat")
% Select offset/noise data at selected reference voltage and group same SA
% designs (including same layout: 2 (SVT/LVT) x 32 = 64 SAs per design)
offset_selected_rt = offset(:,2,:);
offset_reshaped_rt = reshape(offset_selected_rt, 64, []);
noise_selected_rt = noise(:,2,:);
noise_reshaped_rt = reshape(noise_selected_rt, 64, []);
% Calculate normal distribution mu/std estimations
offset_mu_rt = mean(offset_reshaped_rt, 1);
offset_std_rt = std(offset_reshaped_rt, 0, 1);
noise_rms_mu_rt = mean(noise_reshaped_rt, 1);
noise_rms_std_rt = std(noise_reshaped_rt, 0, 1);

% Static memories


%% Load 4K data
% Dynamic memories
load("test5_20230404135523117.mat")
% Select offset/noise data at selected reference voltage and group same SA
% designs (including same layout: 2 (SVT/LVT) x 32 = 64 SAs per design)
offset_selected_4k = offset(:,2,:);
offset_reshaped_4k = reshape(offset_selected_4k, 64, []);
noise_selected_4k = noise(:,2,:);
noise_reshaped_4k = reshape(noise_selected_4k, 64, []);
% Calculate normal distribution mu/std estimations
offset_mu_4k = mean(offset_reshaped_4k, 1);
offset_std_4k = std(offset_reshaped_4k, 0, 1);
noise_rms_mu_4k = mean(noise_reshaped_4k, 1);
noise_rms_std_4k = std(noise_reshaped_4k, 0, 1);

% Static memories


%% Print dynamic table
fprintf("2T NW-PR: RT mu = %.0f(%1.0f), sigma = %.0f(%1.0f). 4K mu = %.0f(%1.0f), sigma = %.0f(%1.0f)\n", 1e3*offset_mu_rt(1), 1e3*offset_std_rt(1)/8, 1e3*offset_std_rt(1), 1e3*offset_std_rt(1)/sqrt(2*64-2), 1e3*offset_mu_4k(1), 1e3*offset_std_4k(1)/8, 1e3*offset_std_4k(1), 1e3*offset_std_4k(1)/sqrt(2*64-2))
fprintf("2T NW-PR: RT noise RMS = %.2f(%1.0f). 4K noise RMS = %.2f(%1.0f)\n", 1e3*noise_rms_mu_rt(1), 1e5*noise_rms_std_rt(1)/8, 1e3*noise_rms_mu_4k(1), 1e5*noise_rms_std_4k(1)/8)
fprintf("3T NW-PR: RT mu = %.0f(%1.0f), sigma = %.0f(%1.0f). 4K mu = %.0f(%1.0f), sigma = %.0f(%1.0f)\n", 1e3*offset_mu_rt(2), 1e3*offset_std_rt(2)/8, 1e3*offset_std_rt(2), 1e3*offset_std_rt(2)/sqrt(2*64-2), 1e3*offset_mu_4k(2), 1e3*offset_std_4k(2)/8, 1e3*offset_std_4k(2), 1e3*offset_std_4k(2)/sqrt(2*64-2))
fprintf("3T NW-PR: RT noise RMS = %.2f(%1.0f). 4K noise RMS = %.2f(%1.0f)\n", 1e3*noise_rms_mu_rt(2), 1e5*noise_rms_std_rt(2)/8, 1e3*noise_rms_mu_4k(2), 1e5*noise_rms_std_4k(2)/8)
fprintf("3T PW-PR: RT mu = %.0f(%1.0f), sigma = %.0f(%1.0f). 4K mu = %.0f(%1.0f), sigma = %.0f(%1.0f)\n", 1e3*offset_mu_rt(3), 1e3*offset_std_rt(3)/8, 1e3*offset_std_rt(3), 1e3*offset_std_rt(3)/sqrt(2*64-2), 1e3*offset_mu_4k(3), 1e3*offset_std_4k(3)/8, 1e3*offset_std_4k(3), 1e3*offset_std_4k(3)/sqrt(2*64-2))
fprintf("3T PW-PR: RT noise RMS = %.2f(%1.0f). 4K noise RMS = %.2f(%1.0f)\n", 1e3*noise_rms_mu_rt(3), 1e5*noise_rms_std_rt(3)/8, 1e3*noise_rms_mu_4k(3), 1e5*noise_rms_std_4k(3)/8)
