;;; Find static read time
; Reduce the read time until a cell fails

; Registers
; R1 = write time
; R2 = row counter
; R3 = settings register data (combined)
; R4 = settings register address
; R5 = settings register data (base)
; R6 = start row
; R7 = final row
; R31 = all-1 (constant)
init $r1 191
init $r2 0
init $r3 0
init $r4 32
init $r5 0b00000000000001001000000011111111
init $r6 0
init $r7 31
init $r31 0xFFFFFFFF

; Write time reduction loop
; Put write setting in settings register and write to settings address
shli $r1 8 $r3
xor $r3 $r5 $r3
write $r3 $r4

; Set row loop register to first row
add $r6 $r0 $r2
; Loop over all rows to see if writes still work
; Write 0, read, write 1, read
write $r0 $r2
read_stop $r0 $r2 $r0
read_stop $r0 $r2 $r0
write $r31 $r2
read_stop $r31 $r2 $r0
read_stop $r31 $r2 $r0

; Increment row loop register and jump back if not at last address yet
addi $r2 1 $r2
bltq $r2 $r7 -7

; Decrease write time and jump back
addi $r1 -1 $r1
beq $r0 $r0 -13