;;; Loop Random Refresh
; Loop refresh instructions with sequential addresses for refresh power 
; measurements after setting the memory to some semi-random pattern

; Memory settings register
; R4 = settings register address
; R5 = settings register data, all settings halfway, SA test mode disabled,
; bitline background enabled and set to 1 (for write 0; set 0 for write 1)
init $r4 0b0000100000
init $r5 0b00011010000010001000000011111111
write $r5 $r4

; Address calculation
; Memory base address + 5-bit part of the address PRNG
; R6 = base address
; R7 = address counter
; R8 = final address
init $r6 0b0000000000
init $r8 0b0000011111

; Pattern of 8 lines which is repeated 4x for initialisation
init $r10 0xAAAAAAAA
init $r11 0x0F0F0F0F
init $r12 0x55555555
init $r13 0xF0F0F0F0
init $r14 0xC3C3C3C3
init $r15 0x99999999
init $r16 0x3C3C3C3C
init $r17 0x66666666

; Initial write (max 26 instructions)
; Start address
add $r6 $r0 $r7
write $r10 $r7
addi $r7 1 $r7
write $r11 $r7
addi $r7 1 $r7
write $r12 $r7
addi $r7 1 $r7
write $r13 $r7
addi $r7 1 $r7
write $r14 $r7
addi $r7 1 $r7
write $r15 $r7
addi $r7 1 $r7
write $r16 $r7
addi $r7 1 $r7
write $r17 $r7
addi $r7 1 $r7
blt $r8 $r7 2
beq $r0 $r0 -17

; Loop: 32 refresh instructions every 290 cycles
; Move start address to R7
add $r6 $r0 $r7
refresh $r7
addi $r7 1 $r7
bltq $r7 $r8 -2

; Loop
beq $r0 $r0 -4