;;; Loop refresh
; Loop refresh instructions with sequential addresses for refresh power 
; measurements

; Memory settings register
; R4 = settings register address
; R5 = settings register data, all settings halfway, SA test mode disabled,
; bitline background enabled and set to 1 (for write 0; set 0 for write 1)
init $r4 0b0000100000
init $r5 0b00011010000010001000000011111111
write $r5 $r4

; Address calculation
; Memory base address + 5-bit part of the address PRNG
; R6 = base address
; R7 = address counter
; R8 = final address
init $r6 0b0000000000
init $r8 0b0000011111

; Loop: 32 refresh instructions every 290 cycles
; Move start address to R7
add $r6 $r0 $r7
refresh $r7
addi $r7 1 $r7
bltq $r7 $r8 -2

; Loop
beq $r0 $r0 -4