;;; Fast row retention assembly file
; Perform write + repeated read operations to determine the first failing 
; cell and an estimate of its retention time

; Memory settings register
; R4 = settings register address
; R5 = settings register data, all settings halfway, SA test mode disabled,
; bitline background enabled and set to 1 (for write 0; set 0 for write 1)
init $r4 0b0000100000
init $r5 0b00011010000010001000000011111111
write $r5 $r4

; Row of interest and data
; R6 = address of row of interest
; R7 = data (opposite of bitline background set in settings register)
init $r6 0b0000000000
init $r7 0x00000000

; Infinite loop broken by read_stop
; R1 = loop counter
init $r1 0

; Write data
write $r7 $r6

; Loop start
; Read data
read_stop $r7 $r6 $r0

; Loop end (jump back)
addi $r1 1 $r1
beq $r0 $r0 -2