wsPaths = [
    'H:\My Documents\CryoMemory_measurements\MATLAB\memoryCharacterisation\singleCellTemperatureRetention_20230313154208619.mat';
    'H:\My Documents\CryoMemory_measurements\MATLAB\memoryCharacterisation\singleCellTemperatureRetention_20230313165307138.mat';
    'H:\My Documents\CryoMemory_measurements\MATLAB\memoryCharacterisation\singleCellTemperatureRetention_20230405095501077.mat';
    'H:\My Documents\CryoMemory_measurements\MATLAB\memoryCharacterisation\singleCellTemperatureRetention_20230314130643921.mat'];

cellName = [
    '3T NW-PR (SVT)';
    '3T NW-PR (LVT)';
    '3T PW-PR (SVT)';
    '3T PW-PR (LVT)'];

scatterColor = {
    [1,0,0], [1,0,0];
    [0,1,0], [0,1,0];
    [0,0,1], [0,0,1];
    [0.2,0.2,0.2], [0.2, 0.2, 0.2]};

lineStyles = {'-', '-', '-', '-'};

% cellName = {'3T NW-PR', '', '3T PW-PR', ''};
% 
% scatterColor = {
%     [0,1,0], [0,1,0];
%     [0,1,0], [0,1,0];
%     [0,0,1], [0,0,1];
%     [0,0,1], [0,0,1]};
% 
% lineStyles = {'-', '--', '-', '--'};

figure(1230)
hold on
% legendText = string.empty(2*numel(wsPaths), 0);
legendText = string.empty(numel(wsPaths), 0);
plotH = NaN(4,1);

for cellIdx = 1:size(wsPaths,1)
    load(wsPaths(cellIdx,:))
    for dataIdx = 1:numel(dataNo)
        x1 = temperature(dataIdx:numel(dataNo):(end-numel(dataNo)));
        x2 = temperature((dataIdx+1):numel(dataNo):(end-numel(dataNo)+1));
        xm = mean([x1; x2]);
        y1 = max((retention(dataIdx,:) - 1) * 360e-9 + 300e-9, 0);
        y2 = (retention(dataIdx,:)) * 360e-9 + 300e-9;
        ym = y1;
%         selection = ym < 1;
%         selection = and(abs(x1-x2) < 3, ym < 1);
        selection = abs(x1-x2) < 3;
        xtemp = xm(selection);
        ytemp = ym(selection);
        [xtemp, itemp] = sort(xtemp);
        ytemp = ytemp(itemp);

        ysmooth = movmean(ytemp,5);
        plotH(cellIdx) = plot(xtemp, ysmooth, lineStyles{cellIdx}, 'Color', scatterColor{cellIdx, dataIdx});

%         plot(xtemp, ytemp, 'Color', scatterColor{cellIdx, dataIdx})
%         scatter(xm(selection), ym(selection), ".", "MarkerEdgeColor", scatterColor{cellIdx, dataIdx})
%         legendText(2*(cellIdx - 1) + dataIdx) = sprintf("%s: data = %d", cellName(cellIdx,:), dataNo(dataIdx));
    end 
end
text(40, 3e-3, {"Low SN", "voltage"})
text(240, 3e-7, {"High SN", "voltage"})
hold off
set(gca, "YScale", "log")
xlabel("Temperature [K]")
ylabel("Retention time [s]")
legend(plotH, cellName, "Location", "best", "AutoUpdate", "off")
% title("3T GC cells: retention time")
grid on
ylim([10^(-7.5), 10^(-1)])
ax = gca;
ax.YTick = 10.^(-7:-1);
ax.YMinorGrid = 'off';
ax.YMinorTick = 'off';

% hold on
% for cellIdx = 1:size(wsPaths,1)
%     load(wsPaths(cellIdx,:))
%     for dataIdx = 1:numel(dataNo)
%         x1 = temperature(dataIdx:numel(dataNo):(end-numel(dataNo)));
%         x2 = temperature((dataIdx+1):numel(dataNo):(end-numel(dataNo)+1));
%         xm = mean([x1; x2]);
%         y1 = max((retention(dataIdx,:) - 1) * 360e-9 + 300e-9, 0);
%         y2 = (retention(dataIdx,:)) * 360e-9 + 300e-9;
%         ym = y1;
% 
%         selection = and(abs(x1-x2) < 3, ym < 1);
%         xm = xm(selection);
%         ym = ym(selection);
% 
%         ym = ym(~isnan(xm));
%         xm = xm(~isnan(xm));
%         F = scatteredInterpolant(xm', randn(size(xm')), ym', "natural");
%         xq = linspace(5,270,21);
%         V = F(xq, zeros(size(xq)));
% 
%         plot(xq, V, "--", "Color", scatterColor{cellIdx, dataIdx})
%     end
% end
% hold off