function [errorCounters, reference, testReference] = ...
    test_5_measurement(MSI, errorCounters, reference, testReference, ...
    inputProgram, testReferenceVoltage, testRefIdx, refIdx, memoryIdx)
%TEST_5_MEASUREMENT Perform the measurement for test 5
%   Detailed explanation goes here
    MSI.setSupplyChannelVoltageSafe(MSI.SUPPLY_CHANNEL_TREF, ...
    testReferenceVoltage)
    
    nRuns = 1;
    errorsAccumulated = zeros(32,1);

    for i = 1:nRuns
        outputProgram = MSI.runProgram(inputProgram);
        errorsAccumulated = errorsAccumulated + ...
            double(outputProgram.ErrorCounter(:));
    end
    errorsAccumulated = errorsAccumulated / nRuns;

    reference(:, testRefIdx, refIdx, memoryIdx) = ...
        MSI.measureSupplyChannelVoltage(MSI.SUPPLY_CHANNEL_REF);
    testReference(:, testRefIdx, refIdx, memoryIdx) = ...
        MSI.measureSupplyChannelVoltage(MSI.SUPPLY_CHANNEL_TREF);
    errorCounters(:, testRefIdx, refIdx, memoryIdx) = ...
        errorsAccumulated;
end

