;;; Test 5 assembly file
; Characterise the SAs by performing 1023 measurements

; Memory settings register
; R4 = settings register address
; R5 = settings register data, all settings halfway, SA test mode disabled
; R6 = settings register with SA test mode enabled
init $r4 0b0000100000
init $r5 0b00000010000010001000000010000000
init $r6 0b00000110000010001000000010000000

; Loop
; R1 = loop variable
; R2 = loop limit
; R3 = target row (must be in selected memory, exact one should not matter)
; R7 = SA polarity
init $r1 0
init $r2 1022
init $r3 0b0000000000
init $r7 0x00000000

; (Re)set the SAs to known polarity
; - Turn off the SA test mode
; - Write SA polarity to the cells
; - Immediately read (to $r8, can be checked for correctness)
write $r5 $r4
write $r7 $r3
read $r3 $r8

; Read and accumulate the ones (compare with $r0)
; - Turn on the SA test mode
; - Read
; - Loop
write $r6 $r4
read_acc $r0 $r3 $r0
addi $r1 1 $r1
bltq $r1 $r2 -6

; Back to test mode disabled and stop
write $r5 $r4
beq $r0 $r0 0