memoryIdx = 3;

fcn = @(b,x) normcdf(x, b(1), b(2));
retTime(rowNo+1,:) = 8e-8 + 2e-8 * reshape(min(criticalDelay( ...
    memoryIdx,:,:,1,:), [], 3), [numel(rowNo), 32]);
% retTime(retTime == min(retTime, [], 'all')) = Inf;
NRCF = @(b) norm(sum(retTime(retTime ~= Inf)' <= retTime(retTime ~= Inf ...
    ), 2)/numel(retTime) - fcn(b, log(retTime(retTime ~= Inf))));
B = fminsearch(NRCF, [-5; 1]);

figure(1)
hold on
ecdf(retTime(:), 'Censoring', retTime(:) == Inf - (retTime(:) == 8e-8), 'Bounds','on')
ax = gca;
ax.XScale = "log";
t = logspace(floor(log10(min(retTime, [], 'all'))), ...
    ceil(log10(max(retTime(retTime ~= Inf), [], 'all'))+1), 100);
dist = cdf('Lognormal', t, B(1), B(2));
if startTemperature < 100
    plotColor = 'b--';
else
    plotColor = 'r--';
end
plot(t, dist, plotColor, 'LineWidth', 2)
if max(dist) > 0.5
    t_text = interp1(dist, t, 0.5);
else
    t_text = max(t);
end
text(t_text*1.2, interp1(t, dist, t_text), sprintf("lnN(%.3f, %.3f)", B))
hold off
xlabel("Retention time [s]")
ylabel("Cell fraction")
%title("2T NW-PR (LVT)")