;;; Test read delay
; Find the capture delay chain setting for which the read fails

; Memory settings register
; R4 = settings register address
; R5 = settings register data (capture delay = 0)
init $r4 0b0000100000
init $r5 0b00011010000010001000000000000000

; Row of interest
; R6 = address of row of interest
; R7 = capture delay chain setting
; R31 = all-1
init $r6 0b0000000000
init $r7 255
init $r31 0xFFFFFFFF

; Loop start
; R8 = setting with capture delay
add $r5 $r7 $r8
write $r8 $r4

; Write all-0, read compare, write all-1, read compare
write $r0 $r6
read_stop $r0 $r6 $r10
write $r31 $r6
read_stop $r31 $r6 $r10

; End of loop: decrement R7 and jump back
addi $r7 -1 $r7
beq $r0 $r0 -7