testFolder = "C:\Users\radamsteegt\Documents\MATLAB\tests\" + ...
    "misc\find_read_delay\";

memoryNo = 0;

reference = 0.12;
% Settings data with capture delay = 0, will be swept by program
% Here, SA test must be ON (1)
settingsData = bin2dec("000"+"001"+"100000"+"1011"+"00110110"+ "00000000");
settingsAddr = 64 * memoryNo + 32;
memoryRow = 64 * memoryNo;

MSI.setSupplyChannelVoltageSafe(MSI.SUPPLY_CHANNEL_REF, reference)

captureDelay = 90;
successful = true;

while successful == true
    captureDelay = captureDelay - 1;
    MSI.memoryWrite(settingsData + captureDelay, settingsAddr)
    
    % 0 volt, must result in all-1
    MSI.setSupplyChannelVoltageSafe(MSI.SUPPLY_CHANNEL_TREF, 0)
    successful = and(successful, MSI.memoryRead(memoryRow) == 0xFFFFFFFF);

    % 0.3 volt, must result in all-0
    MSI.setSupplyChannelVoltageSafe(MSI.SUPPLY_CHANNEL_TREF, 0.3)
    successful = and(successful, MSI.memoryRead(memoryRow) == 0);
end

fprintf("Failing at capture delay <= %d\n", captureDelay)