%% Miscellaneous scripts: Plot Temperature
% Opens a figure in which the temperature is plotted which is being
% measured continuously.

%% Run startup script
% Connect with the FPGA and instruments and set up the initial instrument 
% output values and configurations.

if ~exist("MSI", "var")
    MSI = MeasurementSetupInterface();
end
temperature = MSI.getTemperature();

%% Create figure instance
figure(1000)
pltHandle = plot(temperature);
xlabel("Measurement")
ylabel("Temperature [K]")
title(sprintf("Temp = %.2f K", temperature))

%% Infinite loop
% Loop which records the temperature and updates the figure once every
% second.
while 1
    temperature = [temperature, MSI.getTemperature()];
    pltHandle.YData = temperature;
    pltHandle.Parent.XLim = [1, numel(temperature)];
    pltHandle.Parent.Title.String = sprintf("Temp = %.2f K (%.2f C)", ...
        temperature(end), temperature(end)-273.15);
    pause(1)
end